module tb ();
    reg s0,s1,s2,s3;
    wire e,f,g,h;
    problem1_1 pb1 (
        .s0(s0),
        .s1(s1),
        .s2(s2),
        .s3(s3),
        .e(e),
        .f(f),
        .g(g),
        .h(h)
    );
    // Initialization
    initial 
    begin
        $display("----------------------");
        $display("-- Simulation Start --");
        $display("----------------------");
    end

    //READ file
    integer fd;
    initial
    begin
        fd = $fopen("golden.data","r");
    end
    integer i; //arr idx
    integer fail; // count fail times
    integer count; // total iterations
    reg ge,gf,gg,gh; // golden 
    initial 
    begin
    count = 0;
    fail = 0;
    for( i = 0;i < 16;i = i+1) begin
        s0 = i[0];
        s1 = i[1];
        s2 = i[2];
        s3 = i[3];
        count = count +1;
        $fscanf(fd,"%d %d %d %d",ge,gf,gg,gh);
        #10;
        if((e !== ge) || (f !== gf) || ( g !== gg) || (h !== gh)) begin
            fail = fail + 1;
            $display("Case %d:\n\tInput s0,s1,s2,s3 : %d,%d,%d,%d\n\tExpect e,f,g,h : %d,%d,%d,%d\n\tOutput e,f,g,h : %d,%d,%d,%d\n",count,s0,s1,s2,s3,ge,gf,gg,gh,e,f,g,h);
        end
    end
        if (fail === 0)
        begin
            $display("\n");
            $display("\n");
            $display("        ****************************    _._     _,-'\"\"`-._        ");
            $display("        **  Congratulations !!    **   (,-.`._,'(       |\\`-/|     ");
            $display("        **  Simulation1 PASS!!    **       `-.-' \\ )-`( , o o)     ");
            $display("        ****************************             `-    \\`_`\"'-    ");
            $display("\n");
        end
        else
        begin
            $display("\n");
            $display("\n");
            $display("        ****************************         |\\      _,,,---,,_     ");
            $display("        **  OOPS!!                **   ZZZzz /,`.-'`'    -.  ;-;;,_  ");
            $display("        **  Simulation1 Failed!!  **        |,4-  ) )-,_. ,\\ (  `'-'");
            $display("        ****************************       '---''(_/--'  `-'\\_)     ");
            $display("         Totally has %d errors                     ", fail); 
            $display("\n");
        end
        $fclose(fd);
        $finish;
    end 
endmodule